#define STRICT
#define MARON_CODE_

#include <windows.h>
//#include <windowsx.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "maron.hpp"

// static oϐ̏
winampVisModule Maron::m_VisModule;
HWND Maron::m_hWndWinamp = NULL;

HHOOK Maron::m_hHookCWP = NULL;

char Maron::m_szSkinPath[_MAX_PATH];
char Maron::m_szSkinName[_MAX_PATH];

SkinSuck * Maron::pSkinSuck = NULL;
MaronConfig * Maron::pMaronConfig = NULL;
VisColor * Maron::pVisColor = NULL;

mlCDib * Maron::pBackBuffer = NULL;
mlCDib * Maron::pLevelMeter = NULL;
mlCDib * Maron::pPeakMeter = NULL;

PFUNC_ANALYZERMODE Maron::m_fnAnalyzerMode = Fire;
PFUNC_BLENDCOLOR Maron::m_fnBlendMethod = Ave;
PFUNC_BUFFERUPDATE Maron::m_fnBufferUpdate = DrawBackBufferNop;
PFUNC_BLIT Maron::m_fnBlit = BlitWindowShade;

/* -------------------------------------------------------------------------
 *	RXgN^, fXgN^
 * ---------------------------------------------------------------------- */
Maron::Maron() 
{
	{
		m_VisModule.description		= "MARON";
		m_VisModule.hwndParent		= NULL;
		m_VisModule.hDllInstance	= NULL;
		m_VisModule.sRate			= 0;
		m_VisModule.nCh				= 0;
		m_VisModule.latencyMs		= 15;
		m_VisModule.delayMs			= 15;
		m_VisModule.spectrumNch		= 2;
		m_VisModule.waveformNch		= 0;
		m_VisModule.Config			= Config;
		m_VisModule.Init			= Init;
		m_VisModule.Render			= Render;
		m_VisModule.Quit			= Quit;
	}
}

Maron::~Maron() 
{}

/* -------------------------------------------------------------------------
 *	Winamp Ă΂
 * ---------------------------------------------------------------------- */
int Maron::Init(winampVisModule *this_mod)
{
	m_hWndWinamp = this_mod->hwndParent;

	// ݒǂݍ
	char CommonIniFile[_MAX_PATH];
	GetModuleFileName(m_VisModule.hDllInstance, CommonIniFile, _MAX_PATH);
	char *p = strrchr(CommonIniFile, '\\'); *p = NULL;
	strcat(CommonIniFile, "\\plugin.ini");

	if (!pMaronConfig)
	{
		if (!(pMaronConfig = new MaronConfig(CommonIniFile)))
		{
			MessageBox(m_hWndWinamp, "Can't Initialized MaronConfig Class", m_VisModule.description, MB_ICONEXCLAMATION);
			goto quit;
		}
	}

	// SkinSuck 𐶐
	if (!pSkinSuck)
	{
		pSkinSuck = new SkinSuck;
		if (!pSkinSuck || !pSkinSuck->Init(m_hWndWinamp))
		{
			MessageBox(m_hWndWinamp, "Can't Initialized SkinSuck Class", m_VisModule.description, MB_ICONEXCLAMATION);
			goto quit;
		}
	}

	// Winamp  version  2.04 ȍ~̏ꍇ.
	if (0x2004 <= pSkinSuck->GetVersion())
		pMaronConfig->SetCommonDependSexyFont(FALSE);

	// VisColor IuWFNg𐶐
	if (!pVisColor)
	{
		if (!(pVisColor = new VisColor))
		{
			MessageBox(m_hWndWinamp, "Can't Initialized VisColor Class", m_VisModule.description, MB_ICONEXCLAMATION);
			goto quit;
		}
	}

	// obt@̍쐬
	if (!CreateBuffers())
	{
		DestroyBuffers();
		MessageBox(m_hWndWinamp, "Error setting up buffers", m_VisModule.description, MB_ICONEXCLAMATION);
		goto quit;
	}

	// obt@̏
	m_fnBufferUpdate = InitBuffers;

	if (pMaronConfig->GetDependSexyFont())
	{
		// SexyFont ̃bZ[Wɗ
		if (!(m_hHookCWP = SetWindowsHookEx(WH_CALLWNDPROC, HookProcDependSexyFontCWP, this_mod->hDllInstance, GetWindowThreadProcessId(m_hWndWinamp, NULL))))
		{
			MessageBox(m_hWndWinamp, "Unable to set hook", m_VisModule.description, MB_ICONEXCLAMATION);
			goto quit;
		}

		SendMessage(m_hWndWinamp, WM_WINAMPJ_CONTROL, (WPARAM)WINAMPJ_NOTIFY_CHANGESKIN, (LPARAM)m_hWndWinamp);

		pSkinSuck->GetSkinName(m_szSkinPath, m_szSkinName);

	} else {
		// SkinSuck  Skin ʋ@\gp
		// f[^x[X̍쐬
		pSkinSuck->CreateDatabase();

		// tbNd
		if (!(m_hHookCWP = SetWindowsHookEx(WH_CALLWNDPROC, HookProcIndependent, this_mod->hDllInstance, GetWindowThreadProcessId(m_hWndWinamp, NULL))))
		{
			MessageBox(m_hWndWinamp, "Unable to set hook", m_VisModule.description, MB_ICONEXCLAMATION);
			goto quit;
		}
	}

	return 0;

quit:
	Quit(this_mod);
	return 1;
}

void Maron::Quit(winampVisModule *this_mod)
{

	// tbN
	if (m_hHookCWP)
	{
		UnhookWindowsHookEx(m_hHookCWP);
		m_hHookCWP = NULL;
	}

	// Ƃ肠 nop
	m_fnBufferUpdate = DrawBackBufferNop;
	m_fnBlit = BlitWindowShade;

	// obt@̔j
	DestroyBuffers();

	// VisColor ̔j
	if (pVisColor) 
	{
		delete pVisColor;
		pVisColor = NULL;
	}

	// SkinSuck ̔j
	if (pSkinSuck)
	{
		delete pSkinSuck;
		pSkinSuck = NULL;
	}

	// MaronConfig ̔j
	if (pMaronConfig)
	{
		delete pMaronConfig;
		pMaronConfig = NULL;
	}
}

void Maron::Config(winampVisModule *this_mod)
{
	MessageBox(this_mod->hwndParent,
		"MARON - YAT Anshin! miyuri Visualization Library\n"
		"Copyright(C) 1998, Sakurai Miyuri / Suicidal Machineers",
		"About - MARON",MB_OK);
}

int Maron::Render(winampVisModule *this_mod)
{
	BufferUpdate(this_mod);
	UpdateScreen();

	return 0;
}

/* -------------------------------------------------------------------------
 *	tbNvV[W
 * ---------------------------------------------------------------------- */
LRESULT CALLBACK Maron::HookProcIndependent(int nCode, WPARAM wParam, LPARAM lParam)
{
	CWPSTRUCT* pMsg = (CWPSTRUCT*)lParam;

	if (pMsg->hwnd == m_hWndWinamp)
	{
		switch (pMsg->message)
		{
		case WM_SIZE:
			ChooseBlitFunction();
			break;

		case WM_PAINT:
			// obt@̍ď
			m_fnBufferUpdate = InitBuffers;
			break;

		}
	}

	return CallNextHookEx(m_hHookCWP, nCode, wParam, lParam);
}

LRESULT CALLBACK Maron::HookProcDependSexyFontCWP(int nCode, WPARAM wParam, LPARAM lParam)
{
	CWPSTRUCT* pMsg = (CWPSTRUCT*)lParam;

	if (pMsg->hwnd == m_hWndWinamp)
	{
		switch (pMsg->message)
		{
		case WM_SIZE:
			ChooseBlitFunction();
			break;

		case WM_COPYDATA:
			{
				COPYDATASTRUCT* pcds = (COPYDATASTRUCT*)pMsg->lParam;
				if (pcds->dwData == SEXYFONT_COPYDATA)
				{
					char *p = m_szSkinPath;
					p += pSkinSuck->GetSkinDir(m_szSkinPath);
					memcpy(p, pcds->lpData, pcds->cbData);
					m_fnBufferUpdate = InitBuffers;
				}
			}
			break;
		}
	}

	return CallNextHookEx(m_hHookCWP, nCode, wParam, lParam);
}

/* -------------------------------------------------------------------------
 *	obt@Q̍쐬
 * ---------------------------------------------------------------------- */
BOOL Maron::CreateBuffers()
{
	if (!pBackBuffer)
	{
		if (!(pBackBuffer = new mlCDib)) return FALSE;
		if (!(pBackBuffer->CreateDIB(WINAMPVIS_WIDTH, WINAMPVIS_HEIGHT, 24))) return FALSE;
	}

	if (!pLevelMeter)
	{
		if (!(pLevelMeter = new mlCDib)) return FALSE;
		if (!(pLevelMeter->CreateDIB(WINAMPVIS_WIDTH, WINAMPVIS_HEIGHT*(WINAMPVIS_HEIGHT+1), 24))) return FALSE;
	}

	if (!pPeakMeter)
	{
		if (!(pPeakMeter = new mlCDib)) return FALSE;
		if (!(pPeakMeter->CreateDIB(WINAMPVIS_WIDTH, WINAMPVIS_HEIGHT, 24))) return FALSE;
	}

	return TRUE;
}

/* -------------------------------------------------------------------------
 *	obt@Q̔j
 * ---------------------------------------------------------------------- */
void Maron::DestroyBuffers()
{
	if (pBackBuffer) {delete pBackBuffer; pBackBuffer = NULL;}
	if (pLevelMeter) {delete pLevelMeter; pLevelMeter = NULL;}
	if (pPeakMeter) {delete pPeakMeter; pPeakMeter = NULL;}
}

/* -------------------------------------------------------------------------
 *	obt@̏
 * ---------------------------------------------------------------------- */
void Maron::InitBuffers(winampVisModule *this_mod)
{
	char buf[_MAX_PATH], *p;
	mlCDib *pDibMainBmp = NULL;

	if (!pMaronConfig->GetDependSexyFont())
	{
		// gpXL擾
		if (pSkinSuck->GetSkinName(m_szSkinPath, buf))
		{
			if (!strcmp(m_szSkinName, buf))
			{
				goto quit;	// ω
			} else {
				strcpy (m_szSkinName, buf);
			}
		} else {
			*m_szSkinPath = NULL;
		}
	}

	if (*m_szSkinPath)
	{
		// Skin gp
		strcpy(buf, m_szSkinPath);
		p=buf+strlen(buf);
		*p = '\\'; p++;

		// maron.(txt|ini) ǂݍ
		{
			struct _stat Stat;

			strcpy(p, "maron.txt");
			if (_stat( buf, &Stat))
				strcpy(p, "maron.ini");
		}
		pMaronConfig->ReadIniFile(buf);
		if (!pMaronConfig->GetEnable()) goto quit;

		// viscolor.txt ǂݍ
		strcpy(p, "viscolor.txt");
		pVisColor->ReadFile(buf);

		// DIB IuWFNg쐬
		if(!(pDibMainBmp = new mlCDib)) goto quit;

		// main.BMP ǂݍ
		strcpy(p, "main.bmp");
		if ( !pDibMainBmp->LoadImage(buf) ) goto quit;

		// F[^`
		DrawAlphaLevelMeter(pDibMainBmp);

		BitBlt(pBackBuffer->GetDC(), 0, 0, WINAMPVIS_WIDTH, WINAMPVIS_HEIGHT,
			pLevelMeter->GetDC(), 0, WINAMPVIS_HEIGHT*WINAMPVIS_HEIGHT, SRCCOPY);

	} else {
		// Skin gp(none)
		pMaronConfig->SetEnable(FALSE);
	}

quit:

#ifdef _DEBUG
	// fobOp
	HDC hdcscreen = GetDC(0);
	pBackBuffer->DrawBits (hdcscreen, 0, 0);
	pLevelMeter->DrawBits (hdcscreen, 0, 20);
	pPeakMeter->DrawBits (hdcscreen, 100, 0);
	ReleaseDC(0,hdcscreen);
#endif


	if (pDibMainBmp) delete pDibMainBmp;

	ChooseBlitFunction();

	return;
}

/* -------------------------------------------------------------------------
 *	x[^`悷
 * ---------------------------------------------------------------------- */
void Maron::DrawAlphaLevelMeter(mlCDib *pDibMainBmp)
{
	int i, x, y;

	// main.bmp obt@ɃRs[
	BitBlt (pLevelMeter->GetDC(), 0, 0, WINAMPVIS_WIDTH, WINAMPVIS_HEIGHT,
			pDibMainBmp->GetDC(), WINAMPVIS_X_OFFSET, WINAMPVIS_Y_OFFSET, SRCCOPY);


	// ׂĂwi摜Ŗ߂
	for (i = 1; i < WINAMPVIS_HEIGHT + 1; i++)
	{
		BitBlt (pLevelMeter->GetDC(), 0, WINAMPVIS_HEIGHT * i, WINAMPVIS_WIDTH, WINAMPVIS_HEIGHT,
				pLevelMeter->GetDC(), 0, 0, SRCCOPY);
	}

	// gp֐I
	switch (pMaronConfig->GetAnalyzerMode())
	{
	case MODE_NORMAL:
		m_fnAnalyzerMode = Normal;
		break;

	case MODE_LINES:
		m_fnAnalyzerMode = Lines;
		break;

	case MODE_FIRE:
	default:
		m_fnAnalyzerMode = Fire;
	}

	switch (pMaronConfig->GetBlendMethod())
	{
	case BLEND_ADD:
		m_fnBlendMethod = Add;
		break;

	case BLEND_SUB:
		m_fnBlendMethod = Sub;
		break;

	case BLEND_MIX:
	default:
		m_fnBlendMethod = Ave;
	}

	// x[^`悵Ă䂭
	COLORREF cr, crVisColor;

	if (pMaronConfig->GetRain())
	{
		for (i = 0; i < WINAMPVIS_HEIGHT; i++)
		{
			for (y = 0; y < WINAMPVIS_HEIGHT - i; y++)
			{
				crVisColor = AnalyzerMode(i, WINAMPVIS_HEIGHT - 1 - y);
				for (x = 0; x < WINAMPVIS_WIDTH; x++)
				{
					// ǁ[(^^;
					cr = pLevelMeter->GetPixel(x, WINAMPVIS_HEIGHT * i + y);
					BlendColor(cr, crVisColor);
					pLevelMeter->SetPixel(x, WINAMPVIS_HEIGHT * i + y, cr);
				}
			}
		}
	} else {
		for (i = 0; i < WINAMPVIS_HEIGHT; i++)
		{
			for (y = WINAMPVIS_HEIGHT - 1; y >= i; y--)
			{
				crVisColor = AnalyzerMode(i, y);
				for (x = 0; x < WINAMPVIS_WIDTH; x++)
				{
					// ǁ[(^^;
					cr = pLevelMeter->GetPixel(x, WINAMPVIS_HEIGHT * i + y);
					BlendColor(cr, crVisColor);
					pLevelMeter->SetPixel(x, WINAMPVIS_HEIGHT * i + y, cr);
				}
			}
		}
	}

	if (pMaronConfig->GetPeaks())
	{
		BitBlt (pPeakMeter->GetDC(), 0, 0, WINAMPVIS_WIDTH, WINAMPVIS_HEIGHT,
				pLevelMeter->GetDC(), 0, WINAMPVIS_HEIGHT * WINAMPVIS_HEIGHT, SRCCOPY);

		for (y = 0; y < WINAMPVIS_HEIGHT; y++)
		{
			for (x = 0; x < WINAMPVIS_WIDTH; x++)
			{
				cr = pPeakMeter->GetPixel(x, y);
				BlendColor(cr, pVisColor->m_ColorRef[23]);
				pPeakMeter->SetPixel(x, y, cr);
			}
		}
	}
}

/* -------------------------------------------------------------------------
 *	VisColor ̓Kp@ (Mode)
 * ---------------------------------------------------------------------- */
COLORREF Maron::Normal(int i, int y)
{ return pVisColor->m_ColorRef[y + 2]; }

COLORREF Maron::Fire(int i, int y)
{ return pVisColor->m_ColorRef[y + 2 - i]; }

COLORREF Maron::Lines(int i, int y)
{ return pVisColor->m_ColorRef[i + 2]; }

/* -------------------------------------------------------------------------
 *	F̍
 * ---------------------------------------------------------------------- */
void Maron::Ave(COLORREF &cr1, const COLORREF cr2)
{
	BYTE red, green, blue;

	red   = ((GetRValue(cr1) * (128 - pMaronConfig->GetRatio())) + (GetRValue(cr2) * pMaronConfig->GetRatio())) / 128;
	green = ((GetGValue(cr1) * (128 - pMaronConfig->GetRatio())) + (GetGValue(cr2) * pMaronConfig->GetRatio())) / 128;
	blue  = ((GetBValue(cr1) * (128 - pMaronConfig->GetRatio())) + (GetBValue(cr2) * pMaronConfig->GetRatio())) / 128;

	cr1 = RGB(red, green, blue);
}

void Maron::Add(COLORREF &cr1, const COLORREF cr2)
{
	BYTE red, green, blue;
	int i;

	i = GetRValue(cr1) + (GetRValue(cr2) * pMaronConfig->GetRatio()) / 128;
	if ( i > 0xff )
	{
		red = 0xff;
	} else {
		red = i;
	}

	i = GetGValue(cr1) + (GetGValue(cr2) * pMaronConfig->GetRatio()) / 128;
	if ( i > 0xff )
	{
		green = 0xff;
	} else {
		green = i;
	}

	i = GetBValue(cr1) + (GetBValue(cr2) * pMaronConfig->GetRatio()) / 128;
	if ( i > 0xff )
	{
		blue = 0xff;
	} else {
		blue = i;
	}

	cr1 = RGB(red, green, blue);
}

void Maron::Sub(COLORREF &cr1, const COLORREF cr2)
{
	BYTE red, green, blue;
	int i;

	i = GetRValue(cr1) - (GetRValue(cr2) * pMaronConfig->GetRatio()) / 128;
	if ( i < 0 )
	{
		red = 0;
	} else {
		red = i;
	}

	i = GetGValue(cr1) - (GetGValue(cr2) * pMaronConfig->GetRatio()) / 128;
	if ( i < 0 )
	{
		green = 0;
	} else {
		green = i;
	}

	i = GetBValue(cr1) - (GetBValue(cr2) * pMaronConfig->GetRatio()) / 128;
	if ( i < 0 )
	{
		blue = 0;
	} else {
		blue = i;
	}

	cr1 = RGB(red, green, blue);
}

/* -------------------------------------------------------------------------
 *	ʂւ̓]
 * ---------------------------------------------------------------------- */
void Maron::BlitNormal()
{
	HDC hdc = GetDC(m_hWndWinamp);
	BitBlt (hdc, WINAMPVIS_X_OFFSET, WINAMPVIS_Y_OFFSET, WINAMPVIS_WIDTH, WINAMPVIS_HEIGHT,
			pBackBuffer->GetDC(), 0, 0, SRCCOPY);
	ReleaseDC(m_hWndWinamp,hdc);
}

void Maron::BlitDoubleSize()
{
	HDC hdc = GetDC(m_hWndWinamp);
	StretchBlt (hdc, WINAMPVIS_X_OFFSET*2, WINAMPVIS_Y_OFFSET*2, WINAMPVIS_WIDTH*2, WINAMPVIS_HEIGHT*2,
			pBackBuffer->GetDC(), 0, 0, WINAMPVIS_WIDTH, WINAMPVIS_HEIGHT, SRCCOPY);
	ReleaseDC(m_hWndWinamp,hdc);
}

/* -------------------------------------------------------------------------
 *	draw/blit [`KXI
 * ---------------------------------------------------------------------- */
void Maron::ChooseBlitFunction()
{
	// ɒǉ(₯(
	if (pMaronConfig->GetEnable())
	{
		if (pMaronConfig->GetPeaks())
		{
			if (pMaronConfig->GetRain())
			{
				switch (pSkinSuck->GetWinampSize())
				{
				case SIZE_NORMAL:
					m_fnBlit = BlitNormal;
					m_fnBufferUpdate = DrawBackBufferRainWithPeaks;
					break;

				case SIZE_DOUBLE:
					m_fnBlit = BlitDoubleSize;
					m_fnBufferUpdate = DrawBackBufferRainWithPeaks;
					break;

				case SIZE_SHADE:
				default:
					m_fnBufferUpdate = DrawBackBufferNop;
					m_fnBlit = BlitWindowShade;
					break;
				}
			} else {
				switch (pSkinSuck->GetWinampSize())
				{
				case SIZE_NORMAL:
					m_fnBlit = BlitNormal;
					m_fnBufferUpdate = DrawBackBufferNormalWithPeaks;
					break;

				case SIZE_DOUBLE:
					m_fnBlit = BlitDoubleSize;
					m_fnBufferUpdate = DrawBackBufferNormalWithPeaks;
					break;

				case SIZE_SHADE:
				default:
					m_fnBufferUpdate = DrawBackBufferNop;
					m_fnBlit = BlitWindowShade;
					break;
				}
			}
		} else {
			switch (pSkinSuck->GetWinampSize())
			{
			case SIZE_NORMAL:
				m_fnBlit = BlitNormal;
				m_fnBufferUpdate = DrawBackBufferWithoutPeaks;
				break;

			case SIZE_DOUBLE:
				m_fnBlit = BlitDoubleSize;
				m_fnBufferUpdate = DrawBackBufferWithoutPeaks;
				break;

			case SIZE_SHADE:
			default:
				m_fnBufferUpdate = DrawBackBufferNop;
				m_fnBlit = BlitWindowShade;
				break;
			}
		}
	} else {
		m_fnBlit = BlitWindowShade;
		m_fnBufferUpdate = DrawBackBufferNop;
	}
}

/* -------------------------------------------------------------------------
 *	obNobt@̕`
 * ---------------------------------------------------------------------- */
// 0~255 - > 0~16 ւ̕ϊe[u
const char Maron::m_levelTable[] = {
  0,  1,  1,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  3,  4,
  4,  4,  4,  4,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,
  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  7,  7,  7,
  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  8,  8,  8,  8,  8,  8,
  8,  8,  8,  8,  8,  8,  8,  8,  8,  9,  9,  9,  9,  9,  9,  9,
  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, 10, 10, 10, 10, 10, 10,
 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 11, 11, 11,
 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,
 11, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
 12, 12, 12, 12, 12, 12, 12, 13, 13, 13, 13, 13, 13, 13, 13, 13,
 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 14,
 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
 14, 14, 14, 14, 14, 14, 14, 14, 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
 15, 15, 15, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,
 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16
};

const int Maron::m_pickupTable[] = {
	   1,   2,   3,   4,   5,   6,   7,   8,
	   9,  10,  11,  12,  13,  14,  15,  16,	// 16
	  17,  18,  20,  22,  25,  27,  30,  32,
	  35,  38,  41,  44,  47,  51,  54,  58,	// 32
	  61,  65,  69,  73,  77,  81,  85,  89,
	  93,  98, 102, 107, 112, 116, 121, 126,	// 48
	 131, 136, 141, 146, 151, 157, 162, 167,
	 173, 178, 184, 189, 195, 201, 206, 212,	// 64
	 218, 224, 229, 235, 241, 247, 253, 259,
	 265, 271, 277, 288
};

unsigned char Maron::m_levelLast[WINAMPVIS_WIDTH];		// [^[ŏIXVl
unsigned char Maron::m_levelDiff[WINAMPVIS_WIDTH];		// [^[ŏIXVl̍
unsigned char Maron::m_peakLast [WINAMPVIS_WIDTH];		// s[N[^[ŏIXVl
unsigned char Maron::m_peakDiff [WINAMPVIS_WIDTH];		// s[N[^[ŏIXVl̍
unsigned char Maron::m_peakTime [WINAMPVIS_WIDTH];		// s[N[^[ێ

void Maron::DrawBackBufferWithoutPeaks(winampVisModule *this_mod)
{
	unsigned char value, index;
	char level;
	int x, y;

	x = 0;
#ifdef _BARS
	for ( index = 0; index < WINAMPVIS_WIDTH; index+=4)
	{
		value = 0;
		for (; x < m_pickupTable[index]; x +=4)
#else
	for ( index = 0; index < WINAMPVIS_WIDTH; index++)
	{
		value = 0;
		for (; x < m_pickupTable[index]; x ++)
#endif
		{
			for (y = 0; y < this_mod->spectrumNch; y ++)				// `l
			{
				if ( value < this_mod->spectrumData[y][x] )		// ől擾
					 value = this_mod->spectrumData[y][x];
			}
		}

		UpdateLevel (index, value, level);

		DrawOneLevel (index, level, 0);
	}
}

void Maron::DrawBackBufferNormalWithPeaks(winampVisModule *this_mod)
{
	unsigned char value, index;
	char level, peak;
	int x, y;

	x = 0;
#ifdef _BARS
	for ( index = 0; index < WINAMPVIS_WIDTH; index+=4)
	{
		value = 0;
		for (; x < m_pickupTable[index]; x +=4)
#else
	for ( index = 0; index < WINAMPVIS_WIDTH; index++)
	{
		value = 0;
		for (; x < m_pickupTable[index]; x ++)
#endif
		{
			for (y = 0; y < this_mod->spectrumNch; y ++)				// `l
			{
				if ( value < this_mod->spectrumData[y][x] )		// ől擾
					 value = this_mod->spectrumData[y][x];
			}
		}

		UpdateLevel (index, value, level);

		UpdatePeakNormal (index, value, level, peak);

		DrawOneLevel (index, level, peak);
	}
}

void Maron::DrawBackBufferRainWithPeaks(winampVisModule *this_mod)
{
	unsigned char value, index;
	char level, peak;
	int x, y;

	x = 0;
#ifdef _BARS
	for ( index = 0; index < WINAMPVIS_WIDTH; index+=4)
	{
		value = 0;
		for (; x < m_pickupTable[index]; x +=4)
#else
	for ( index = 0; index < WINAMPVIS_WIDTH; index++)
	{
		value = 0;
		for (; x < m_pickupTable[index]; x ++)
#endif
		{
			for (y = 0; y < this_mod->spectrumNch; y ++)				// `l
			{
				if ( value < this_mod->spectrumData[y][x] )		// ől擾
					 value = this_mod->spectrumData[y][x];
			}
		}

		UpdateLevel (index, value, level);

		UpdatePeakRain (index, value, level, peak);

		DrawOneLevel (index, level, peak);
	}
}

void Maron::UpdateLevel(const unsigned char index, const unsigned char value, char & level)
{
	// x
	level = m_levelTable[m_levelLast[index]] - m_levelDiff[index];

	// tFC̏
	if (level > 0)
	{
		m_levelDiff[index] += FALLOFF_SPEED_LEVEL;
	} else {
		level = 0;
		m_levelLast[index] = 0;
		m_levelDiff[index] = 0;
	}

	// ŐV̒lĂꍇ
	if (level < m_levelTable[value])
	{
		level = m_levelTable[value];
		m_levelLast[index] = value;
		m_levelDiff[index] = FALLOFF_SPEED_LEVEL;
	}
}

void Maron::UpdatePeakNormal(const unsigned char index, const unsigned char value, const char level, char & peak)
{
	const char MaximumLevelValue = m_levelTable[255];

	// s[Nz[h
	peak = m_levelTable[m_peakLast[index]];
	peak -= MaximumLevelValue - m_levelTable[255 - m_peakDiff[index]];	// normal

	// s[N̏
	if (m_peakTime[index])
	{
		// ێԂfNg
		m_peakTime[index] --;
	} else {
		// tFC̏
		if (peak < 0 ||
			m_peakDiff[index] >= 256 - FALLOFF_SPEED_PEAK)
		{
			peak = 0;
			m_peakLast[index] = 0;
			m_peakDiff[index] = 0;
		} else {
			if (m_peakLast[index] != 0)
				m_peakDiff[index] += FALLOFF_SPEED_PEAK;
		}
	}

	// xs[NĂꍇ
	if (peak < level)
	{
		peak = level;
		m_peakLast[index] = m_levelLast[index];
		m_peakDiff[index] = 0;
		// ێԂ^
		m_peakTime[index] = PEAK_HOLD_DELAY;
	}
}

void Maron::UpdatePeakRain(const unsigned char index, const unsigned char value, const char level, char & peak)
{
	const char MaximumLevelValue = m_levelTable[255];

	// s[Nz[h
	peak = m_levelTable[m_peakLast[index]];
	peak += MaximumLevelValue - m_levelTable[255 - m_peakDiff[index]];	// rain

	// s[N̏
	if (m_peakTime[index])
	{
		// ێԂfNg
		m_peakTime[index] --;
	} else {
		// tFC̏
		if (MaximumLevelValue < peak ||
			m_peakDiff[index] >= 256 - FALLOFF_SPEED_PEAK)
		{
			peak = 0;
			m_peakLast[index] = 0;
			m_peakDiff[index] = 0;
		} else {
			if (m_peakLast[index] != 0)
				m_peakDiff[index] += FALLOFF_SPEED_PEAK;
		}
	}

	// xs[NĂꍇ
	if (peak < level)
	{
		peak = level;
		m_peakLast[index] = m_levelLast[index];
		m_peakDiff[index] = 0;
		// ێԂ^
		m_peakTime[index] = PEAK_HOLD_DELAY;
	}

	// peak ̈ʒu㉺]
	peak = (MaximumLevelValue + 1) - peak;
}

void Maron::DrawOneLevel(unsigned char index, char level, char peak)
{
	LPSTR pSrc, pDst;

	pSrc = (LPSTR)pLevelMeter->GetBitsPtr() + (pLevelMeter->GetWidthBytes() * level * WINAMPVIS_HEIGHT) + (index * 3);
	pDst = (LPSTR)pBackBuffer->GetBitsPtr() + index * 3;

	for (int i = WINAMPVIS_HEIGHT; i; i--)
	{
#ifdef _BARS
		((LONG*)pDst)[0] = ((LONG*)pSrc)[0];
		((LONG*)pDst)[1] = ((LONG*)pSrc)[1];
		pDst[8] = pSrc[8];
#else
		pDst[0] = pSrc[0];
		pDst[1] = pSrc[1];
		pDst[2] = pSrc[2];
#endif

		pSrc += pLevelMeter->GetWidthBytes();
		pDst += pBackBuffer->GetWidthBytes();
	}

	if (peak > 0 && peak <= WINAMPVIS_HEIGHT)
	{
		pSrc = (LPSTR)pPeakMeter->GetBitsPtr() + (index * 3) + (pPeakMeter->GetWidthBytes() * (peak - 1));
		pDst = (LPSTR)pBackBuffer->GetBitsPtr() + (index * 3) + (pBackBuffer->GetWidthBytes() * (peak - 1));

#ifdef _BARS
		((LONG*)pDst)[0] = ((LONG*)pSrc)[0];
		((LONG*)pDst)[1] = ((LONG*)pSrc)[1];
		pDst[8] = pSrc[8];
#else
		pDst[0] = pSrc[0];
		pDst[1] = pSrc[1];
		pDst[2] = pSrc[2];
#endif
	}
}
